package com.rjconsultores.ventaboletos.rest;

import javax.annotation.security.RolesAllowed;
import javax.ws.rs.Consumes;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;

import org.slf4j.Logger;

import com.rjconsultores.ventaboletos.rest.bean.ParamsSincronizarOperador;
import com.rjconsultores.ventaboletos.rest.service.ConsultarOperadorService;
import com.rjconsultores.ventaboletos.vo.embarcada.OperadorEmbarcadaVO;
import com.rjconsultores.ventaboletos.web.utilerias.spring.AppContext;

@Path("/consultarOperadorProxy")
public class ConsultarOperador {
	private static Logger log = org.slf4j.LoggerFactory.getLogger(ConsultarOperador.class);
			
	@POST
	@Consumes({ MediaType.APPLICATION_JSON })
	@RolesAllowed("EMBARCADA")
	@Produces({ MediaType.APPLICATION_JSON })
	public OperadorEmbarcadaVO buscarDadosOperador(ParamsSincronizarOperador params) {
		long start = System.currentTimeMillis();
		
		ConsultarOperadorService service = (ConsultarOperadorService) AppContext.getApplicationContext().getBean("consultarOperadorService");
		OperadorEmbarcadaVO vo = service.buscarDadosOperador(params); 
		
		printInfo("/consultarOperadorProxy", start);
		
		return vo;
	}
	
	private void printInfo(String service, long start) {
		long milliseconds = System.currentTimeMillis() - start;
		long minutes = (milliseconds / 1000) / 60;
		long seconds = (milliseconds / 1000) % 60;

		String info = String.format("[%s] %d minutos e %d segundos", service, minutes, seconds);
		
		if ((minutes + seconds) == 0) {
			info = String.format("[%s] %d milissegundos", service, milliseconds);
		}
		
		log.info(info);
	}
}
