/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.ingreso;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.Calendar;
import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Checkbox;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Radio;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.constantes.Constantes;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.entidad.TipoEventoExtra;
import com.rjconsultores.ventaboletos.entidad.TipoEventoExtraEmpresa;
import com.rjconsultores.ventaboletos.entidad.TipoEventoExtraPtoVta;
import com.rjconsultores.ventaboletos.exception.BusinessException;
import com.rjconsultores.ventaboletos.exception.ValidacionCampoException;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.service.TipoEventoExtraEmpresaService;
import com.rjconsultores.ventaboletos.service.TipoEventoExtraPtovtaService;
import com.rjconsultores.ventaboletos.service.TipoEventoExtraService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxEstandar;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxPuntoVenta;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;

/**
 *
 * @author Rafius
 */
@Controller("editarTipoEventoExtraController")
@Scope("prototype")
public class EditarTipoEventoExtraController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private TipoEventoExtraService tipoEventoExtraService;
	@Autowired
	private TipoEventoExtraEmpresaService tipoEventoExtraEmpresaService;
	@Autowired
	private EmpresaService empresaService;	
	@Autowired
	private TipoEventoExtraPtovtaService tipoEventoExtraPtovtaService;

	private TipoEventoExtra tipoEventoExtra;
	private MyListbox tipoEventoExtraList;
	private MyListbox empresasList;
	private MyListbox agenciasList;
	private MyTextbox txtNome;
	private Button btnApagar;
	private Button btnSalvar;
	private Textbox impMax;
	private Checkbox cbValidaDocumento;
	private Radio raTipo11;  
	private Radio raTipo22;
	private MyComboboxEstandar cmbEmpresa;
	private MyComboboxPuntoVenta cmbPontoVenda;
	private List<Empresa> lsEmpresas;
	private List<com.rjconsultores.ventaboletos.constantes.TipoEventoExtra> lsEventoExtrasConstantes;
	private MyComboboxEstandar cmbCveTipoEvento;

	private static Logger log = Logger.getLogger(EditarTipoEventoExtraController.class);

	public TipoEventoExtra getTipoEventoExtra() {
		return tipoEventoExtra;
	}

	public void setTipoEventoExtra(TipoEventoExtra tipoEventoExtra) {
		this.tipoEventoExtra = tipoEventoExtra;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		lsEmpresas = empresaService.obtenerTodosIncluindoEmpresaTodas(); 
		lsEventoExtrasConstantes = Arrays.asList(com.rjconsultores.ventaboletos.constantes.TipoEventoExtra.values());

		super.doAfterCompose(comp); 

		tipoEventoExtra = (TipoEventoExtra) Executions.getCurrent().getArg().get("tipoEventoExtra");
		tipoEventoExtraList = (MyListbox) Executions.getCurrent().getArg().get("tipoEventoExtraList");

		//lsTipoEventoExtraEmpresas = tipoEventoExtra.getTipoeventoextraId() == null ? new ArrayList<TipoEventoExtraEmpresa>() : tipoEventoExtraEmpresaService.buscarPorTipoEventoExtra(tipoEventoExtra);
		empresasList.setData(tipoEventoExtra.getEmpresas());
		agenciasList.setData(tipoEventoExtra.getPontosventa());

		if (tipoEventoExtra.getTipoeventoextraId() != null) {
			cbValidaDocumento.setChecked(tipoEventoExtra.getIndvalidadocumento());
		} else {
			btnApagar.setVisible(false);
		}

		if (tipoEventoExtra.getIndtipo() != null) {
			if (tipoEventoExtra.getIndtipo().equals("1")) {
				raTipo11.setChecked(Boolean.TRUE);
				raTipo22.setChecked(Boolean.FALSE);
			} else {
				raTipo11.setChecked(Boolean.FALSE);
				raTipo22.setChecked(Boolean.TRUE);
			}
		}

		if( (tipoEventoExtra.getTipoeventoextraId() != null) && (tipoEventoExtra.getTipoeventoextraId() > Constantes.LIMITE_EVENTO_EXTRA_EDITAVEL) ){
			btnApagar.setVisible(false);
			btnSalvar.setVisible(false);
		}

		if(tipoEventoExtra.getCvetipoevento() != null) {
			cmbCveTipoEvento.setValue(tipoEventoExtra.getCvetipoevento().toString());
		}

		txtNome.focus();
	}

	public void onClick$btnRemoverEmpresa(Event ev) throws InterruptedException {
		if (empresasList.getSelectedItem() == null){
			Messagebox.show(Labels.getLabel("editarTipoEventoExtraController.MSG.selecionarEmpresa"),
					Labels.getLabel("editarTipoEventoExtraController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);
			return;
		}

		TipoEventoExtraEmpresa t = (TipoEventoExtraEmpresa) empresasList.getSelected();

		tipoEventoExtraEmpresaService.borrar(t);

		tipoEventoExtra.removeEmpresa(t);
		empresasList.setData(tipoEventoExtra.getEmpresas());
	}

	public void onClick$btnAdicionarEmpresa(Event ev) throws InterruptedException {
		if (cmbEmpresa.getSelectedItem() == null){
			Messagebox.show(Labels.getLabel("editarTipoEventoExtraController.MSG.selecionarEmpresa"),
					Labels.getLabel("editarTipoEventoExtraController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);
			return;
		}
		Empresa e = (Empresa) cmbEmpresa.getSelectedItem().getValue();

		tipoEventoExtra.addEmpresa(e);

		empresasList.setData(tipoEventoExtra.getEmpresas());
	}

	public void onClick$btnAdicionarAgencia(Event ev) throws InterruptedException {
		if (cmbPontoVenda.getSelectedItem() == null){
			Messagebox.show(Labels.getLabel("editarTipoEventoExtraController.MSG.selecionarPuntoVenta"),
					Labels.getLabel("editarTipoEventoExtraController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);
			return; 
		}
		PuntoVenta p = (PuntoVenta) cmbPontoVenda.getSelectedItem().getValue();

		tipoEventoExtra.addPuntoVenta(p);

		agenciasList.setData(tipoEventoExtra.getPontosventa());
	}
	
	public void onClick$btnRemoverAgencia(Event ev) throws InterruptedException {
		if (agenciasList.getSelectedItem() == null){
			Messagebox.show(Labels.getLabel("editarTipoEventoExtraController.MSG.selecionarPuntoVenta"),
					Labels.getLabel("editarTipoEventoExtraController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);
			return;
		}

		TipoEventoExtraPtoVta t = (TipoEventoExtraPtoVta) agenciasList.getSelected();

		tipoEventoExtraPtovtaService.borrar(t);

		tipoEventoExtra.removePuntoVenta(t);
		agenciasList.setData(tipoEventoExtra.getPontosventa());
	}
	
	public void onClick$btnSalvar(Event ev) throws InterruptedException {
		txtNome.getValue();
		impMax.getValue();

		tipoEventoExtra.setIndoperacion(TipoEventoExtra.OPERACION_NORMAL);
		tipoEventoExtra.setIndboleto(Boolean.FALSE);// no valida boleto
		tipoEventoExtra.setPorciva(BigDecimal.ZERO);
		tipoEventoExtra.setIndtipo(raTipo11.isChecked() ? "1" : "0");

		if(cmbCveTipoEvento.getSelectedItem() != null) {
			if (cmbCveTipoEvento.getSelectedItem().getValue().toString().equals(" ")){
				tipoEventoExtra.setCvetipoevento(null);
			} else {
				tipoEventoExtra.setCvetipoevento(com.rjconsultores.ventaboletos.constantes.TipoEventoExtra.valueOf(cmbCveTipoEvento.getSelectedItem().getValue().toString()));
			}
		}

		try {
			tipoEventoExtra.setActivo(Boolean.TRUE);
			tipoEventoExtra.setFecmodif(Calendar.getInstance().getTime());
			tipoEventoExtra.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

			List<TipoEventoExtra> lsTipoEventoExtra = tipoEventoExtraService.buscar(tipoEventoExtra.getDescTipoEvento());
			boolean podeSalvar = false;
			if (lsTipoEventoExtra.isEmpty()) {
				podeSalvar = true;
			} else {
				for (TipoEventoExtra b : lsTipoEventoExtra) {
					if (b.getTipoeventoextraId().equals(tipoEventoExtra.getTipoeventoextraId())) {
						podeSalvar = true;
					}
				}
			}
			if (!podeSalvar) {
				Messagebox.show(Labels.getLabel("MSG.Registro.Existe"),
						Labels.getLabel("editarTipoEventoExtraController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);

				return;
			} else {
				tipoEventoExtra.setIndvalidadocumento(cbValidaDocumento.isChecked());
				if (tipoEventoExtra.getTipoeventoextraId() == null) {
					tipoEventoExtraService.suscribir(tipoEventoExtra);
					tipoEventoExtraList.addItemNovo(tipoEventoExtra);
				} else {
					tipoEventoExtraService.actualizacion(tipoEventoExtra);
					tipoEventoExtraList.updateItem(tipoEventoExtra);
				}
			}

			Messagebox.show(Labels.getLabel("editarTipoEventoExtraController.MSG.suscribirOK"),
					Labels.getLabel("editarTipoEventoExtraController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);

			closeWindow();

		} catch (ValidacionCampoException ve) {
			log.error("editarTipoEventoExtraController: ", ve);
			Messagebox.show(
					ve.getMessage(),
					Labels.getLabel("editarTipoEventoExtraController.window.title"),
					Messagebox.OK, Messagebox.ERROR);

		} catch (Exception ex) {
			log.error("editarTipoEventoExtraController: " + ex);
			Messagebox.show(Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarTipoEventoExtraController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}

	public void onClick$btnApagar(Event ev) throws InterruptedException {
		try {
			int resp = Messagebox.show(Labels.getLabel("editarTipoEventoExtraController.MSG.borrarPergunta"),
					Labels.getLabel("editarTipoEventoExtraController.window.title"),
					Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

			if (resp == Messagebox.YES) {
				tipoEventoExtraService.borrar(tipoEventoExtra);

				Messagebox.show(Labels.getLabel("editarTipoEventoExtraController.MSG.borrarOK"),
						Labels.getLabel("editarTipoEventoExtraController.window.title"), Messagebox.OK,
						Messagebox.INFORMATION);

				tipoEventoExtraList.removeItem(tipoEventoExtra);

				closeWindow();
			}

		} catch (BusinessException ex) {
			Messagebox.show(ex.getLocalizedMessage(),
					Labels.getLabel("editarTipoEventoExtraController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);
		}
	}

	public List<Empresa> getLsEmpresas() {
		return lsEmpresas;
	}

	public void setLsEmpresas(List<Empresa> lsEmpresas) {
		this.lsEmpresas = lsEmpresas;
	}

	public MyComboboxEstandar getCmbCveTipoEvento() {
		return cmbCveTipoEvento;
	}

	public void setCmbCveTipoEvento(MyComboboxEstandar cmbCveTipoEvento) {
		this.cmbCveTipoEvento = cmbCveTipoEvento;
	}

	public List<com.rjconsultores.ventaboletos.constantes.TipoEventoExtra> getLsEventoExtrasConstantes() {
		return lsEventoExtrasConstantes;
	}

	public void setLsEventoExtrasConstantes(List<com.rjconsultores.ventaboletos.constantes.TipoEventoExtra> lsEventoExtrasConstantes) {
		this.lsEventoExtrasConstantes = lsEventoExtrasConstantes;
	}

}
